/* vc_init.c

   Ambros Marzetta 94-11-20
   For more information see our WWW page at
   
         http://wwwjn.inf.ethz.ch/ambros/zram.html
	 
 * $Source: /home/schilte/marzetta/work/distr/zram/RCS/vc_init.c,v $
 * $Revision: 1.1 $
 * $Date: 1998/04/15 08:47:29 $
 * $Log: vc_init.c,v $
 * Revision 1.1  1998/04/15  08:47:29  marzetta
 * Initial revision
 *
 *
 */

#include <stdlib.h>
#include "z_bb.h"
#include "z_ps.h"
#include "vc_br.h"
#include "vc_ub.h"
#include "vc_base.h"
#include "z_signal.h"

#if !defined(NULL)
#define NULL 0L
#endif

static z_bb_ProcSet vc_procset;
int vc_procsetnum;
int vc_NodeTag, vc_GlobalTag;

static void accessMemory(void)
{
  char *p;
  long i;
  const int size = 100000;
  
  p = (char *) malloc(size * sizeof(char));
  for (i = size-1; i >= 0; i -= 1024) p[i] = 1;
  free(p);
} /* accessMemory */
     
void initproc(void)
{
  /* This function is called once on every processing element. */

  z_signal_Init();
  s_bb1_Init();
  z_bb1_Init();
  z_bb2_Init();
  z_bb3_Init();
  z_bb4_Init();

  vc_NodeTag = z_InstallClass(vc_Node, 0, 0, 0);
  vc_GlobalTag = z_InstallClass(vc_Global, 0, 0, 0);
  
  vc_procset.bb_Branch = (z_bb_BranchProc)vc_Branch;
  vc_procset.bb_BranchInPlace = NULL;
  vc_procset.bb_UpperBound = (z_bb_UpperBoundProc)vc_UpperBound1;
  vc_procset.bb_CompareProc = (z_bb_CompareProc)vc_CompareProc;
  vc_procset.bb_IsSolution = (z_bb_IsSolutionProc)vc_IsSolution;
  vc_procset.bb_ShortNodeString =
    (z_bb_ShortNodeStringProc)vc_ShortNodeString;

  vc_procsetnum = z_InstallProcSet((z_ProcSetP) &vc_procset);
  accessMemory();
}


